package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.zhongzheng.common.exception.CustomException;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.bo.CourseSectionAddBo;
import com.zhongzheng.modules.course.bo.CourseSectionEditBo;
import com.zhongzheng.modules.course.bo.CourseSectionQueryBo;
import com.zhongzheng.modules.course.domain.CourseSection;
import com.zhongzheng.modules.course.mapper.CourseMapper;
import com.zhongzheng.modules.course.mapper.CourseSectionMapper;
import com.zhongzheng.modules.course.service.ICourseSectionService;
import com.zhongzheng.modules.course.vo.CourseSectionVo;
import com.zhongzheng.modules.polyv.service.IPolyvVideoService;
import com.zhongzheng.modules.polyv.vo.PolyvVideoQuerVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 课程小节Service业务层处理
 *
 * @author hjl
 * @date 2021-05-19
 */
@Service
public class CourseSectionServiceImpl extends ServiceImpl<CourseSectionMapper, CourseSection> implements ICourseSectionService {

    @Autowired
    private IPolyvVideoService iPolyvVideoService;

    @Autowired
    private CourseSectionMapper courseSectionMapper;

    @Override
    public CourseSectionVo queryById(Long sectionId){
        CourseSection db = this.baseMapper.selectById(sectionId);
        return BeanUtil.toBean(db, CourseSectionVo.class);
    }

    @Override
    public List<CourseSectionVo> queryList(CourseSectionQueryBo bo) {
        LambdaQueryWrapper<CourseSection> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getChapterId() != null, CourseSection::getChapterId, bo.getChapterId());
        lqw.like(StrUtil.isNotBlank(bo.getName()), CourseSection::getName, bo.getName());
        lqw.eq(StrUtil.isNotBlank(bo.getVideoUrl()), CourseSection::getVideoUrl, bo.getVideoUrl());
        lqw.eq(bo.getVideoTime() != null, CourseSection::getVideoTime, bo.getVideoTime());
        lqw.in(bo.getStatus() != null, CourseSection::getStatus, bo.getStatus());
        return entity2Vo(this.list(lqw));
    }

    @Override
    public List<CourseSectionVo> selectList(CourseSectionQueryBo bo) {
        return courseSectionMapper.selectCourseSectionList(bo);
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<CourseSectionVo> entity2Vo(Collection<CourseSection> collection) {
        List<CourseSectionVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, CourseSectionVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<CourseSection> page = (Page<CourseSection>)collection;
            Page<CourseSectionVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(CourseSectionAddBo bo) {
        CourseSection add = BeanUtil.toBean(bo, CourseSection.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(CourseSectionEditBo bo) {
        CourseSection update = BeanUtil.toBean(bo, CourseSection.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(CourseSection entity) {
        //TODO 做一些数据校验,如唯一约束
        if(StringUtils.isNotBlank(entity.getVid())){
            try{
                PolyvVideoQuerVo polyvVideo = iPolyvVideoService.queryById(entity.getVid());
                if(polyvVideo == null){
                    throw new CustomException("保利威视频不存在");
                }
                entity.setPolyvId(polyvVideo.getPolyvId());
            }catch (Exception e){
                throw new CustomException("保利威视频错误");
            }

        }

    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
